
var nrdp = {
    _channelName : "acquisitionBridge",
    _messageChannel : null,
    _cbs : {},

    _nextRid : 1,

    get isReady() { return true; },
    get messageChannel() {
        if (this._messageChannel == null) {
            this._messageChannel = eval("window.webkit.messageHandlers." + this.channelName + ".postMessage");
        }
        return this._messageChannel;
    },
    get channelName() { return this._channelName; },
    set channelName(name) {
        if (typeof name === "string" && name != this.channelName) {
            this._channelName = name;
            this._messageChannel = null;
        }
    },
    get nextRid() { return this._nextRid++; },

    _fn: function(method, args, cb) {
        if (!args) args = {};

        var message = { action : "invoke",
            rid : this.nextRid,
            method : method,
            args : args };

        if (cb)
            this._cbs[message.rid] = cb;

        this._invoke(message);
    },

    _invoke: function(message) {
        window.webkit.messageHandlers.acquisitionBridge.postMessage(message);
//        nrdp.messageChannel(message);
    },

    receiveMessage: function(message) {
        if (!message) return;

        var rid = message.rid;

        if (rid) {
            if (typeof this._cbs[rid] == "function") {
                var removeListener = true;
                if (message.data && message.data.state) {
                    if (message.data.state != "failed" && message.data.state != "completed") {
                        removeListener = false;
                    }
                }
                this._cbs[rid](message.data);
                if (removeListener) {
                    delete this._cbs[rid];
                }
            }
        }
    },

    device: {
        fetchPrices: function(SKUs, cb) {
            nrdp._fn("fetchPrices", {SKUs : SKUs}, cb);
        },
        purchase: function(SKU, trialPref, partnerId, transactionId, cb) {
            nrdp._fn("purchase", {SKU : SKU, trialPref : trialPref, partnerId : partnerId, transactionId : transactionId}, cb);
        },
        restoreReceipt: function(cb) {
            nrdp._fn("restoreReceipt", {}, cb);
        },
        requestDeviceToken: function(cb) {
            nrdp._fn("requestDeviceToken", {}, cb);
        }
    },

    registration: {
        tokenActivate: function(tokens, cb) {
            nrdp._fn("tokenActivate", { tokens : tokens }, cb );
        }
    }
};
